<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL$
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Michael Clay <claym@osuosl.org>                             |
// +------------------------------------------------------------------------+
// $Id: RangeEditForm.php 4660 2006-07-25 17:52:41Z schonstal $

require_once(FORMDIR."/RangeCreateForm.php");

class RangeEditForm extends RangeCreateForm
{

    function form_init_data() 
    {
        $range = new Range($_REQUEST['id']);
        $formary = $this->remap($range->toArray(), FORM);
        foreach($formary as $label=>$val)
            $this->set_element_value($label, $val);
        $this->set_element_value(_("Comment"), _("Range Updated"));
    }

    function form_action()
    {
        global $user;
        $res = true;

        switch(strtolower($this->get_action())) {

        case 'submit':
            $vals = $this->get_all_element_values();
            $range = new Range($_REQUEST['id']);
            $range->query("BEGIN");
            $range->setFrom($this->remap($vals, DBDO));
            $range->setSubnet(null); //must set own subnet!
            if($range->update() === false) {
                $range->query("ROLLBACK");
                $this->add_error(_("ERROR"), _("DB Entry could not be modified"));
                $res = false;
            } else {
                $range->query("COMMIT");
                $range->write_history($vals[_("Comment")], ACTION_MODIFY, 
                                    $user->username);
            }
            break;

        default:
            $this->add_error(_("ERROR"),_("Unknown form action"));
            $res = false;

        }
        
        return $res;
        
    }

/* why was this here?
    function form_backend_validation()
    {
        return true;
    }*/

    function form_success()
    {
        $div = html_div("msuccess");
        $div->add(container(_("Range successfully updated!")),  html_br());
        $div->add(container(html_a("index.php", _("[Return to Home]")), html_a("range.php", _("[Return to Range List]"))));
        return $div;
    }
//{{{   form_hidden()

    /**
     *  Add some hidden values that we'll need later.  The ID of the Range and the
     *  get action so we can get back to the form. All forms which are on pages
     *  that contain multiple forms and or datalists will need to do this (I think).
     *
     *
     *  @return Container   Container that has the hidden elements in it
     */
    function form_hidden()
    {
        $action =  new FEHidden(_("action"), $_REQUEST['action']);
        $id = new FEHidden(_("id"), $_REQUEST['id']);

        $this->add_elements($action, $id);

        return container($this->element_form(_('action')), $this->element_form(_('id')));
    }

//}}}


}

?>
